<template>
  <div>
    <mainNavBar></mainNavBar>
    <v-app>
      <div class="agenda">
        <v-row class="fill-height">
          <v-col>
            <v-sheet height="64">
              <v-toolbar flat color="white">
                <v-btn color="primary" dark @click.stop="dialog = true">
                  Nouvel évènement
                </v-btn>
                <v-btn outlined class="mr-4" @click="setToday">
                  Aujourd'hui
                </v-btn>
                <v-btn fab text small @click="prev">
                  <v-icon small>mdi-chevron-left</v-icon>
                </v-btn>
                <v-btn fab text small @click="next">
                  <v-icon small>mdi-chevron-right</v-icon>
                </v-btn>

                <v-toolbar-title>{{ title }}</v-toolbar-title>
                <div class="flex-grow-1"></div>
                <v-menu bottom right>
                  <template v-slot:activator="{ on }">
                    <v-btn outlined v-on="on">
                      <span>{{ typeToLabel[type] }}</span>
                      <v-icon right>mdi-menu-down</v-icon>
                    </v-btn>
                  </template>
                  <v-list>
                    <v-list-item @click="type = 'day'">
                      <v-list-item-title>Jour</v-list-item-title>
                    </v-list-item>
                    <v-list-item @click="type = 'week'">
                      <v-list-item-title>Semaine</v-list-item-title>
                    </v-list-item>
                    <v-list-item @click="type = 'month'">
                      <v-list-item-title>Mois</v-list-item-title>
                    </v-list-item>
                    <v-list-item @click="type = '4day'">
                      <v-list-item-title>4 prochains jours</v-list-item-title>
                    </v-list-item>
                  </v-list>
                </v-menu>
              </v-toolbar>
            </v-sheet>

            <v-dialog v-model="dialog" max-width="500">
              <v-card>
                <v-container>
                  <v-form @submit.prevent="addEvent">
                    <v-text-field
                      v-model="name"
                      type="text"
                      label="Nom de l'évenement (obligatoire)"
                    ></v-text-field>
                    <v-text-field
                      v-model="details"
                      type="text"
                      label="details"
                    ></v-text-field>
                    <v-text-field
                      v-model="start"
                      type="date"
                      label="Début (obligatoire)"
                    ></v-text-field>
                    <v-text-field
                      v-model="end"
                      type="date"
                      label="Fin (obligatoire)"
                    ></v-text-field>
                    <v-text-field
                      v-model="color"
                      type="color"
                      label="couleur(click pour ouvrir le menu couleur)"
                    ></v-text-field>
                    <v-btn
                      type="submit"
                      color="primary"
                      class="mr-4"
                      @click.stop="dialog = false"
                    >
                      Créer l'évènement
                    </v-btn>
                  </v-form>
                </v-container>
              </v-card>
            </v-dialog>

            <v-sheet height="600">
              <v-calendar
                ref="calendar"
                v-model="focus"
                color="primary"
                :events="events"
                :event-color="getEventColor"
                :event-margin-bottom="3"
                :now="today"
                :type="type"
                @click:event="showEvent"
                @click:more="viewDay"
                @click:date="viewDay"
                @change="updateRange"
              ></v-calendar>
              <v-menu
                v-model="selectedOpen"
                :close-on-content-click="false"
                :activator="selectedElement"
                full-width
                offset-x
              >
                <v-card color="grey lighten-4" min-width="350px" flat>
                  <v-toolbar :color="selectedEvent.color" dark>
                    <v-btn @click="deleteEvent(selectedEvent.id)" icon>
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                    <v-toolbar-title
                      v-html="selectedEvent.name"
                    ></v-toolbar-title>
                    <div class="flex-grow-1"></div>
                  </v-toolbar>
                  <v-card-text>
                    <form v-if="currentlyEditing !== selectedEvent.id">
                      {{ selectedEvent.details }}
                    </form>
                    <form v-else>
                      <textarea-autosize
                        v-model="selectedEvent.details"
                        type="text"
                        style="width: 100%"
                        :min-height="100"
                        placeholder="add note"
                      >
                      </textarea-autosize>
                    </form>
                  </v-card-text>
                  <v-card-actions>
                    <v-btn text color="secondary" @click="selectedOpen = false">
                      fermer
                    </v-btn>
                    <v-btn
                      v-if="currentlyEditing !== selectedEvent.id"
                      text
                      @click.prevent="editEvent(selectedEvent)"
                    >
                      editer
                    </v-btn>
                    <v-btn
                      text
                      v-else
                      type="submit"
                      @click.prevent="updateEvent(selectedEvent)"
                    >
                      Sauvegarder
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-menu>
            </v-sheet>
          </v-col>
        </v-row>
      </div>
    </v-app>
  </div>
</template>

<script>
import { db } from "@/main";
import mainNavBar from "../layout/mainNavBar.vue";

export default {
  name: "Agenda",
  components: {
    mainNavBar,
  },
  data: () => ({
    today: new Date().toISOString().substr(0, 10),
    focus: new Date().toISOString().substr(0, 10),
    type: "month",
    typeToLabel: {
      month: "Month",
      week: "Week",
      day: "Day",
      "4day": "4 Days",
    },
    name: null,
    details: null,
    start: null,
    end: null,
    color: "#1976D2", // default event color
    currentlyEditing: null,
    selectedEvent: {},
    selectedElement: null,
    selectedOpen: false,
    events: [],
    dialog: false,
  }),
  mounted() {
    this.getEvents();
  },
  computed: {
    title() {
      const { start, end } = this;
      if (!start || !end) {
        return "";
      }
      const startMonth = this.monthFormatter(start);
      const endMonth = this.monthFormatter(end);
      const suffixMonth = startMonth === endMonth ? "" : endMonth;
      const startYear = start.year;
      const endYear = end.year;
      const suffixYear = startYear === endYear ? "" : endYear;
      const startDay = start.day; 
      const endDay = end.day; 
      switch (this.type) {
        case "month":
          return `${startMonth} ${startYear}`;
        case "week":
        case "4day":
          return `${startMonth} ${startDay} ${startYear} - ${suffixMonth} ${endDay} ${suffixYear}`;
        case "day":
          return `${startMonth} ${startDay} ${startYear}`;
      }
      return "";
    },
    monthFormatter() {
      return this.$refs.calendar.getFormatter({
        timeZone: "UTC",
        month: "long",
      });
    },
  },
  methods: {
    // ***********************************************************************************************
    // *                    Lecture de la base de données et des évènements existants                *
    // ***********************************************************************************************
    async getEvents() {
      let snapshot = await db.collection("calEvent").get();
      const events = [];
      snapshot.forEach((doc) => {
        let appData = doc.data();
        appData.id = doc.id;
        events.push(appData);
      });
      this.events = events;
    },
    setDialogDate({ date }) {
      this.dialogDate = true;
      this.focus = date;
    },
    viewDay({ date }) {
      this.focus = date;
      this.type = "day";
    },
    getEventColor(event) {
      return event.color;
    },
    setToday() {
      this.focus = this.today;
    },
    prev() {
      this.$refs.calendar.prev();
    },
    next() {
      this.$refs.calendar.next();
    },

    // *****************************************************************************************************
    // *                           Ajouter un évènement                                                    *
    // *****************************************************************************************************
    async addEvent() {
      if (this.name && this.start && this.end) {
        await db.collection("calEvent").add({
          name: this.name,
          details: this.details,
          start: this.start,
          end: this.end,
          color: this.color,
        });
        this.getEvents();
        (this.name = ""),
          (this.details = ""),
          (this.start = ""),
          (this.end = ""),
          (this.color = "");
      } else {
        alert(
          "Vous devez entrer un nom, un debut et une fin obligatoirement!!!"
        );
      }
    },
    // ***************************************************************************************************
    // *                                        Editer un évènement                                      *
    // ***************************************************************************************************
    editEvent(ev) {
      this.currentlyEditing = ev.id;
    },
    async updateEvent(ev) {
      await db
        .collection("calEvent")
        .doc(this.currentlyEditing)
        .update({
          details: ev.details,
        });
      this.selectedOpen = false;
      this.currentlyEditing = null;
      this.getEvents();
    },
    // ****************************************************************************************************
    // *                      Supprimer un évènement                                                      *
    // ****************************************************************************************************
    async deleteEvent(ev) {
      await db
        .collection("calEvent")
        .doc(ev)
        .delete();
      this.selectedOpen = false;
      this.getEvents();
    },
    showEvent({ nativeEvent, event }) {
      const open = () => {
        this.selectedEvent = event;
        this.selectedElement = nativeEvent.target;
        setTimeout(() => (this.selectedOpen = true), 10);
      };
      if (this.selectedOpen) {
        this.selectedOpen = false;
        setTimeout(open, 10);
      } else {
        open();
      }
      nativeEvent.stopPropagation();
    },
    updateRange({ start, end }) {
      this.start = start;
      this.end = end;
    },
  },
};
</script>

<style scoped>
.agenda {
  box-sizing: border-box;
  height: 100%;
}

h2 {
  color: #1b445a;
}
h1 {
  font-family: "BlueEyes";
}
.big {
  font-family: "BrighlyCrush";
  font-weight: 1100;
}
</style>
